//@author: vux
//@help: standard constant shader
//@tags: color
//@credits: 

Texture2D Texture <string uiname="Texture";>;
Texture2D LastTexture <string uiname="LastTexture";>;
SamplerState Linear <string uiname="Sampler State";>
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;
};

 
cbuffer cbPerDraw : register( b0 )
{
	//float4x4 tVP : VIEWPROJECTION;
};


cbuffer cbPerObj : register( b1 )
{

	float2   EyeToSourceUVScale;
	float2   EyeToSourceUVOffset;
	//float2 OverdriveScales;
	//float AaDerivativeMult;
};

struct VS_IN
{
	float3 Position : POSITION;
	
	float2 TexCoord0   : TEXCOORD;
    float2 TexCoord1   : TEXCOORD1;
    float2 TexCoord2   : TEXCOORD2;
	float2 TexCoord3   : TEXCOORD3;
};

struct vs2ps
{
    float4 oPosition: SV_POSITION;
    float1 oColor: COLOR;
	float2 oTexCoord0 : TEXCOORD0;
    float2 oTexCoord1 : TEXCOORD1;
    float2 oTexCoord2 : TEXCOORD2;
};

vs2ps VS(VS_IN input)
{
	vs2ps Out = (vs2ps)0;
	
    Out.oPosition.x = input.Position.x;
    Out.oPosition.y = input.Position.y;
    Out.oPosition.z = 0.5;
    Out.oPosition.w = 1.0;

    // Scale them into  UV lookup space
    float2 tc0scaled = EyeToSourceUVScale * input.TexCoord0 + EyeToSourceUVOffset;
    float2 tc1scaled = EyeToSourceUVScale * input.TexCoord1 + EyeToSourceUVOffset;
    float2 tc2scaled = EyeToSourceUVScale * input.TexCoord2 + EyeToSourceUVOffset;

    Out.oTexCoord0  = tc0scaled;        // R sample.
    Out.oTexCoord1  = tc1scaled;        // G sample.
    Out.oTexCoord2  = tc2scaled;        // B sample.
    Out.oColor      = input.TexCoord3.y;          // Used for vignette fade.
	
    return Out;
}




float4 PS(vs2ps In): SV_Target
{
	
	//return float4((In.oTexCoord0-In.oTexCoord1)*100,0,1);
	float3 newColor;
	// High quality anti-aliasing in distortion

		float ResultR = Texture.Sample(Linear, In.oTexCoord0).r;
		float ResultG = Texture.Sample(Linear, In.oTexCoord1).g;
		float ResultB = Texture.Sample(Linear, In.oTexCoord2).b;
		newColor = float3(ResultR, ResultG, ResultB);
	
	newColor = newColor * In.oColor.xxx;
	float4 outColor0 = float4(newColor, 1.0);
	
	

    return outColor0;
}





technique10 Constant
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
	}
}




